/* Calcul de factoriel                         */
/* Evaluation du temps d'execution             */

public class TestFactorielEnConsole {

/////////////////////////////////////////////////

/* Calcul de n! par methode recursive          */
/*  - 0! = 1                                   */
/*  - n! = (n-1)!*n                            */

  static long factorielRecursif(int n) {
    if ( n == 0 ) {
      return 1; }
      else {
      return factorielRecursif(n-1)*n; }
  }

/* Calcul de n! par methode sequentielle       */

  static long factorielSequentiel(int n) {
    long res = 1;
    if ( n > 1 )
      for ( int i = 2 ; i <= n ; i++ ) {
        res = res*i; }
    return res;
  }

  static void testsFactoriel(int temps,int ni,int nf,int inc) {
    Console.afficherln("Itératif   récursif");
    Console.formater("%6s%21s%12s%14s%14s%14s%12s%14s%14s%14s\n",
                   "Niveau","Resultat","Appels","Temps total",
                   "Temps moyen","o(n)",
                   "Appels","Temps total","Temps moyen","o(n)");
    for ( int nu = ni ; nu <= nf ; nu = nu+inc ) {
      long n  = factorielSequentiel(nu);
      { Utilitaires.Minuteur mntr = new Utilitaires.Minuteur();
        mntr.temps = temps*1000;
        mntr.lancement();
        long i = 0;
        long ti = System.nanoTime();
        do {
          factorielSequentiel(nu);
          i++; }
        while ( mntr.enCours );
        long t = System.nanoTime()-ti;
        Console.formater("%6d%21d%12d%14d%14.3f%14.4f",
                       nu,n,i,t,(double) t/i,(double) t/i/nu); }
      { Utilitaires.Minuteur mntr = new Utilitaires.Minuteur();
        mntr.temps = temps*1000;
        mntr.lancement();
        long i = 0;
        long ti = System.nanoTime();
        do {
          factorielRecursif(nu);
          i++; }
        while ( mntr.enCours );
        long t = System.nanoTime()-ti;
        Console.formater("%12d%14d%14.3f%14.4f\n",
                       i,t,(double) t/i,(double) t/i/nu); } }
  }

/////////////////////////////////////////////////

/* Programme principal                         */

  public static void main(String [] args) {
    Console.setTitle("TestFactoriel");
    Console.afficher("Nombre de secondes de test? ");
    int temps = Console.saisirInt();
    Console.afficher("Niveau initial?   ");
    int ni = Console.saisirInt();
    Console.afficher("Niveau de fin ?   ");
    int nf = Console.saisirInt();
    Console.afficher("Increment     ?   ");
    int inc = Console.saisirInt();
    testsFactoriel(temps,ni,nf,inc);
  }
}